=== test/CMakeLists.txt ===
# cmake-format: off
# Copyright (c) 2022-2024, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Intel Corporation nor the names of its contributors
#       may be used to endorse or promote products derived from this software
#       without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# cmake-format: on

# Ensure building entire project
if(NOT FULL_PROJECT_BUILD)
  message(FATAL_ERROR "Please run CMake from project root directory")
endif()

# build imb-kat application
add_subdirectory(kat-app)

# build imb-xvalid application
add_subdirectory(xvalid-app)

# build imb-wycheproof application
add_subdirectory(wycheproof-app)

# build imb-mp application
add_subdirectory(mp-app)

if(NOT WINDOWS)
  # build imb-acvp if libacvp available
  if(NOT ACVP_LOC)
    set(ACVP_LOC "/usr/local/acvp")
  endif()
  set(ACVP_INCLUDE_DIR "${ACVP_LOC}/include")

  # find libacvp
  find_library(
    ACVP_LIB libacvp.a libacvp
    PATHS ${ACVP_LOC}
    PATH_SUFFIXES lib)

  # add imb-acvp app if found
  if(ACVP_LIB)
    message(STATUS "ACVP_LIB...                ${ACVP_LIB}")
    add_subdirectory(acvp-app)
  endif()

  # add fuzz apps if using clang
  if(CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_subdirectory(fuzz-app)
  endif()
endif()
