=== debian/changelog ===
intel-ipsec-mb (2.0.1-2) unstable; urgency=medium

  * Orphan upload
  * Update Maintainer field to Debian QA Group <packages@qa.debian.org>
    so package can be orphaned

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 15 Sep 2025 14:38:12 +0100

intel-ipsec-mb (2.0.1-1) unstable; urgency=medium

  * Sync to latest 2.0.1 release
  * Remove external doc hypertext links to clean up privacy-breach-generic
    warnings

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 14 Jul 2025 11:57:23 +0100
