=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

DESTDIR=$$(pwd)/debian/tmp
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
HDRDIR=/usr/include
MANDIR=/usr/share/man/man7
DOCDIR=/usr/share/doc

VERSION_MAJOR=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f1)
VERSION_MINOR=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f2)
VERSION_PATCH=$(shell grep -e "IMB_VERSION_STR" lib/intel-ipsec-mb.h | cut -d'"' -f2 | cut -d'.' -f3)

MAN1 = libipsec-mb.7
MAN2 = libipsec-mb-dev.7

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_configure:

override_dh_auto_build:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=OFF
	find . -type f -name "*.o" -print -exec rm {} \;
	$(shell dpkg-buildflags --export=sh); dh_auto_build --
	find $$(pwd) -name "libIPSec_MB.*" -exec ls -al {} \;

	#dh_auto_install

	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON
	find . -type f -name "*.o" -print -exec rm {} \;
	$(shell dpkg-buildflags --export=sh); dh_auto_build --
	find $$(pwd) -name "libIPSec_MB.*" -exec ls -al {} \;

	find $$(pwd) -name "libIPSec_MB.so*" -exec ls -al {} \;
	find $$(pwd) -name "libIPSec_MB.a" -exec ls -al {} \;
	#dh_auto_install

override_dh_auto_install:
	#find $$(pwd) -name "libIPSec_MB.so*" -exec ls -al {} \;
	#find $$(pwd) -name "libIPSec_MB.a" -exec ls -al {} \;
	dh_auto_configure -- -DBUILD_SHARED_LIBS=OFF
	dh_auto_install
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON
	dh_auto_install

#
# Disable elf debug optimization step
#
override_dh_dwz:

%:
	dh $@
	dh_makeshlibs
	dh_shlibdeps
