=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?V?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
             https://github.com/intel/intel-ipsec-mb/tags \
             (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
