## intel-ipsec-mb 2.0.1+dfsg

=== debian/changelog ===
intel-ipsec-mb (2.0.1+dfsg-1) sid; urgency=medium

  * Merging upstream version 2.0.1+dfsg.
  * Wrap and sorting debian files.
  * Removing rules-requires-root field, not needed anymore.
  * Re-adding source priority field for reprepro compatibility (#1110733).
  * Updating vcs fields.
  * Removing unused pre-depends fields.
  * Harmonizing watch file.
  * Tidy copyright file.
  * Tidy debhelper install files.
  * Tidy debhelper docs files.
  * Harmonizing build-depends.
  * Tidy rules file.
  * Harmonizing architecture fields.
  * Harmonizing package descriptions.
  * Reworking rules to do the same but much simpler.
  * Removing remove-makefile.patch, not needed anymore when using build
    directories.
  * Removing docs-index.patch, not needed anymore as docs aren't included
    anymore.
  * Removing lintian-overrides, not needed anymore.
  * Adding upstream metadata.
  * Updating years in copyright for 2026.

 -- Daniel Baumann <daniel@debian.org>  Sat, 03 Jan 2026 03:34:43 +0100

intel-ipsec-mb (2.0.1-4) sid; urgency=medium

  * New maintainer (Closes: #1111169).

 -- Daniel Baumann <daniel@debian.org>  Fri, 02 Jan 2026 18:40:54 +0100

intel-ipsec-mb (2.0.1-3) unstable; urgency=medium

  * QA upload.
  * Maintain in Debian team on Salsa
  * d/watch: version=5
  * No explicit Build-Depends: debhelper
  * Standards-Version: 4.7.3 (routine-update)
  * Remove Priority field to comply with Debian Policy 4.7.3 (routine-
    update)
  * Update lintian override info format in d/source/lintian-overrides
  * d/copyright: Review

 -- Andreas Tille <tille@debian.org>  Tue, 23 Dec 2025 21:48:12 +0100
