=== debian/control ===
Source: intel-ipsec-mb
Section: utils
Priority: optional
Maintainer: Daniel Baumann <daniel@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 nasm,
Standards-Version: 4.7.3
Homepage: https://github.com/intel/intel-ipsec-mb
Vcs-Browser: https://forgejo.debian.net/intel/intel-ipsec-mb
Vcs-Git: https://forgejo.debian.net/intel/intel-ipsec-mb

Package: libipsec-mb2
Section: libs
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Intel Multi-Buffer Crypto for IPsec (library)
 The Multi-Buffer Crypto for IPsec library provides software crypto acceleration
 primarily targeting packet processing applications, e.g. DPDK and QAT.
 .
 This package contains the shared library.

Package: libipsec-mb-dev
Section: libdevel
Architecture: amd64
Depends:
 libipsec-mb2 (= ${binary:Version}),
 ${misc:Depends},
Description: Intel Multi-Buffer Crypto for IPsec (development)
 The Multi-Buffer Crypto for IPsec library provides software crypto acceleration
 primarily targeting packet processing applications, e.g. DPDK and QAT.
 .
 This package contains the development files.
