=== debian/rules ===
#!/usr/bin/make -f

%:
	dh ${@}

execute_after_dh_auto_clean:
	rm -rf build-static
	rm -rf build-shared

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-static -- -DBUILD_SHARED_LIBS=OFF
	dh_auto_configure --builddirectory=build-shared -- -DBUILD_SHARED_LIBS=ON

override_dh_auto_build:
	dh_auto_build --builddirectory=build-static
	dh_auto_build --builddirectory=build-shared

override_dh_auto_test:
	dh_auto_test --builddirectory=build-static
	dh_auto_test --builddirectory=build-shared

override_dh_auto_install:
	dh_auto_install --builddirectory=build-static
	dh_auto_install --builddirectory=build-shared
