=== debian/watch ===
Version: 5

Template: Github
Owner: intel
Project: @PACKAGE@
Dversion-Mangle: auto
